
#define THREAD_INC(X);         \
  asm volatile                 \
    ("\n"                      \
     "lock; incl %0\n\t"       \
     : "=m" (X));


#define THREAD_DEC(X);         \
  asm volatile                 \
    ("\n"                      \
     "lock; decl %0\n\t"       \
     : "=m" (X));

#define SEM_VAR pthread_mutex_t
#define SEM_INIT(x) pthread_mutex_init(&x,NULL);
#define SEM_LOCK(x) pthread_mutex_lock(&x)
#define SEM_UNLOCK(x) pthread_mutex_unlock(&x)
#define SEM_DESTROY(x) pthread_mutex_destroy(&x)

